﻿#include <iostream>

#include "Pool.h"

class Object {
private:
	char _data = '\0';
public:
	Object(char = '\0');
	bool operator==(const Object&) const; 
	// const Object& operator=(const Object&); // Mandatory for complex embedded data...
	bool is_null() const;
	void nullify();
};
Object::Object(char data) : _data(data) {}
bool Object::operator==(const Object& object) const {return _data == object._data;}
bool Object::is_null() const { return _data == '\0'; }
void Object::nullify() { _data = '\0'; }

int main() {
	Pool<Object> pool;
	// Resource injection design pattern, i.e., 'pool' is injected from outside (and may shared by other 'Facade' objects):
	Facade<decltype(pool)::CONTENT> facade(pool); // <=> 'Facade<Object> facade(pool);'
	Object o1('1'), o2('2'), o3('3');
	facade.Create({ o1, o2, o3 });
	facade.Delete({ o1 });

	return 0;
}